  import java.awt.Graphics;
  import java.awt.Event;
  import java.applet.Applet;
  import java.applet.AudioClip;
  import java.awt.Color;
  import java.awt.Font;
  import java.awt.Image;
  import java.awt.FontMetrics;

  class PixOffset{
    public int x, y;
    public int numberOffset;

    PixOffset() {
      x = y = 0;
      numberOffset = 1;
    }

    PixOffset(int x, int y) {
      this.x = x;
      this.y = y;
      numberOffset = 1;
    }
  }
   
  public class game15 extends Applet implements Runnable {
      private          Thread paintThread = null;
      int              cell[][];
      PixOffset[][]    offset;
      int              numberOffsetY;
      int              cellSize;             //    
      int              fontSize;             //  
      int              dx, dy;               //  ( )
      int              selX, selY; //  

      boolean          moving;
      Image            back;
      AudioClip        clickSound;
      String           soundName;
      Image            cellImage;
      Image            horizImg;
      Graphics         horizGraph;
      Image            vertImg;
      Graphics         vertGraph;
      Color            zeroColor;
      Font             font;
      int              tics;

      private void randomFill() {
        //   
        int i, j;
        int filled[] = new int[16];

        for (i = 0; i < 16; i++)
          filled[i] = 0;
        for (i = 0, j = 0; i < 16; i++) {
          j = (int)((j + Math.round(Math.random()*15)) % 16);
          while (filled[j] != 0) {
            j++;
            if (j == 16)
              j = 0;
          }
          cell[ i / 4 ][ i % 4 ] = j;
          filled[j] = 1;
        }
      }

      //     cell[][], offset[][]  font
      public void calcNumberOffsets() {
        int          i, j;
        FontMetrics  fontMetrics;
        String       number;

        //    :(
        Image    tmpImg = createImage( 1, 1);
        Graphics tmpG = tmpImg.getGraphics();
        tmpG.setFont( font );
        fontMetrics = tmpG.getFontMetrics();

        for (i = 0; i < 4; i++)
          for (j = 0; j < 4; j++) {
            number = (new Integer(cell[i][j])).toString();
            offset[i][j].numberOffset = (cellSize -
                fontMetrics.stringWidth( number )) / 2;
          }
      }

      public void init() {
        moving       = false;

        //  
        cell   = new int[4][4];
        randomFill();

        //  
        offset = new PixOffset[4][4];
        for (int i = 0; i < 4; i++)
          for (int j = 0; j < 4; j++)
            offset[i][j] = new PixOffset( 0, 0);

        //   
        String cellStr = getParameter("cell");
        if (cellStr == null)
          cellSize = 20;
        else
          cellSize = Integer.parseInt( cellStr );
        if (cellSize < 16)
          cellSize = 20;

        //   
        String fontStr = getParameter("font");
        if (fontStr == null) 
          fontSize = cellSize - 8;
        else
          fontSize = Integer.parseInt( fontStr );
        if (fontSize < 8)
          fontSize = 8;

        setFont( font = new Font( "TimesNewRoman", Font.BOLD, fontSize ) );

        //   
        calcNumberOffsets();
        numberOffsetY = (cellSize + fontSize)/2;

        //   
        back = getImage( getCodeBase(), "game15.gif" );

        //  
        cellImage = createImage( cellSize, cellSize );
        Graphics g = cellImage.getGraphics();
        //  
        g.setColor( Color.gray );
        g.drawLine( 0, 0, cellSize - 1, 0);
        g.drawLine( 0, 1, 0, cellSize - 1);
        g.setColor( Color.black );
        g.drawLine( cellSize - 1, 1, cellSize - 1, cellSize - 1);
        g.drawLine( 1, cellSize - 1, cellSize - 2, cellSize - 1);
        //   
        g.setColor( new Color( 0xFFEB00 ) );
        g.fillRect( 1, 1, cellSize - 2, 2);
        g.fillRect( 1, cellSize - 3, cellSize - 2, 2);
        g.fillRect( 1, 3, 2, cellSize - 6);
        g.fillRect( cellSize - 3, 3, 2, cellSize - 6);
        //  
        g.setColor( new Color( 0xFFCF36 ) );
        g.fillRect( 3, 3, cellSize - 6, cellSize - 6);

        //   .  . 
        zeroColor = new Color( 0xFFCF36 );
        horizImg   = createImage( cellSize << 1, cellSize );
        horizGraph = horizImg.getGraphics();
        horizGraph.setFont ( font );
        horizGraph.setColor( zeroColor );
        vertImg    = createImage( cellSize, cellSize << 1 );
        vertGraph  = vertImg.getGraphics();
        vertGraph.setColor( zeroColor );
        vertGraph.setFont ( font );

        //  
        String ticsStr = getParameter("tics");
        if (ticsStr == null)
          tics = 5;
        else
          tics = Integer.parseInt( ticsStr );

        //   
        soundName = getParameter("sound");
        if (soundName == null)
          soundName = "game15.au";

        clickSound = getAudioClip( getCodeBase(), soundName );

      }

      public void start() {
          if (paintThread == null) {
              paintThread = new Thread(this, "Paint");
              paintThread.start();
          }
      }

      public boolean playerWon() {
        int i;

        for (i = 0; i < 15; i++)
          if (cell[i % 4][i / 4] != (i + 1))
            break;
        return ( (i == 15) ? true : false );
      }

      public void run() {
          int i;

          Thread myThread = Thread.currentThread();
          while (paintThread == myThread) {
            if (moving) {
              clickSound.play();
              offset[selX][selY].x = 0; offset[selX][selY].y = 0;
              for (i = 0; i < (cellSize - 1); i++) {
                offset[selX][selY].x += dx;
                offset[selX][selY].y += dy;
                repaint();
                try {
                  Thread.sleep(tics);
                } catch (InterruptedException e){ }
              }
              moving = false;
              cell[selX+dx][selY+dy] = cell[selX][selY];
              cell[selX][selY] = 0;
              offset[selX][selY].x = offset[selX][selY].y = 0;
              offset[selX + dx][selY + dy].numberOffset = 
                  offset[selX][selY].numberOffset;
              repaint();
              if (playerWon()) {
                play( getCodeBase(), "win.au" );
                randomFill();
                calcNumberOffsets();
                repaint();
              }
            }
            else
              try {
                Thread.sleep(200);
              } catch (InterruptedException e){ }
        }
      }

      private void paintCell(Graphics g, int x, int y, int xOffs, int yOffs) {
        Image    tmp;
        Graphics tmpG;
        Color    oldColor;

        if (cell[x][y] == 0) {
          oldColor = g.getColor();
          g.setColor( zeroColor );
          g.fillRect( xOffs , yOffs , cellSize, cellSize );
          g.setColor( oldColor );
        }
        else {
          tmp = createImage( cellSize, cellSize );
          tmpG = tmp.getGraphics();
          tmpG.drawImage( cellImage, 0, 0, this );
          tmpG.setColor( Color.black );
          tmpG.setFont( g.getFont() );
          tmpG.drawString( (new Integer(cell[x][y])).toString(),
                           offset[x][y].numberOffset,
                           numberOffsetY );
          g.drawImage( tmp, xOffs, yOffs, this );
        }
      }

      public void update(Graphics g) {
        if (moving) {
          if (dx == +1) {
            horizGraph.fillRect( 0, 0, cellSize << 1, cellSize);
            paintCell( horizGraph, selX, selY,
                       offset[selX][selY].x, offset[selX][selY].y);
            g.drawImage( horizImg,
                         selX*cellSize + 1, selY*cellSize + 1, this); 
          }
          else {
            if (dx == -1) {
              horizGraph.fillRect( 0, 0, cellSize << 1, cellSize);
              paintCell( horizGraph, selX, selY,
                         cellSize +1 + offset[selX][selY].x,
                         offset[selX][selY].y);
              g.drawImage( horizImg,
                           (selX-1)*cellSize + 1, selY*cellSize + 1, this );
            }
            else {
              if (dy == +1) {
                vertGraph.fillRect( 0, 0, cellSize, cellSize << 1);
                paintCell( vertGraph, selX, selY,
                           offset[selX][selY].x, offset[selX][selY].y );
                g.drawImage( vertImg,
                             selX*cellSize + 1, selY*cellSize + 1, this );
              }
              else {
                if (dy == -1) {
                  vertGraph.fillRect( 0, 0, cellSize, cellSize << 1);
                  paintCell( vertGraph, selX, selY,
                             offset[selX][selY].x,
                             cellSize + 1 + offset[selX][selY].y);
                  g.drawImage( vertImg,
                               selX*cellSize + 1, (selY-1)*cellSize + 1, this );
                }
              }
            }
          }
        }
        else
          paint(g);
      }

      public void paintPuzzle(Graphics g) {
        Image    tmp;
        Graphics tmpG;
        int      x, y;

        tmp  = createImage( cellSize * 4, cellSize * 4 );
        tmpG = tmp.getGraphics();
        tmpG.setColor( zeroColor );
        tmpG.setFont( font );
        tmpG.fillRect( 0, 0, cellSize * 4, cellSize * 4 );
        if (moving) {
          for ( x = 0; x < 4; x++)
            for (y = 0; y < 4; y++)
              if (cell[x][y] != cell[selX][selY])
                paintCell( tmpG, x, y, x*cellSize + offset[x][y].x,
                                       y*cellSize + offset[x][y].y);
          x = selX; y = selY;
          paintCell( tmpG, x, y, x*cellSize + offset[x][y].x,
                                 y*cellSize + offset[x][y].y);
        }
        else {
          for ( x = 0; x < 4; x++)
            for (y = 0; y < 4; y++)
              paintCell( tmpG, x, y, x*cellSize + offset[x][y].x,
                                     y*cellSize + offset[x][y].y);
        }
        g.drawImage( tmp, 1, 1, this );
      }

      public void paint(Graphics g) {
        int x, y;

        Image    tmp = createImage( size().width, size().height );
        Graphics tmpG = tmp.getGraphics();
        tmpG.setFont( g.getFont() );

        
        //  

        tmpG.setColor( Color.blue );
        tmpG.fillRect( 0, 0, size().width, size().height);
        if (back != null)
          tmpG.drawImage( back, (cellSize*4) + 3, 1, this );

        paintPuzzle( tmpG );
        g.drawImage( tmp, 0, 0, this );
      }

      public boolean mouseDown(Event e, int x, int y ) {
        if (moving)
          return true;
        //  
        if ((x == 0) || (y == 0))
          return (true);
        selX = (x-1) / cellSize;
        selY = (y-1) / cellSize;
        if ((selX < 4) && (selY < 4)) {
          //  
          // 
          if (((selX - 1) >= 0) && (cell[selX-1][selY] == 0)) {
            dx = -1;
            dy = 0;
            moving = true;
            return true;
          }
          // 
          if (((selY - 1) >= 0) && (cell[selX][selY-1] == 0)) {
            dx = 0;
            dy = -1;
            moving = true;
            return true;
          }
          // 
          if (((selX + 1) <= 3) && (cell[selX+1][selY] == 0)) {
            dx = +1;
            dy = 0;
            moving = true;
            return true;
          }
          // 
          if (((selY + 1) <= 3) && (cell[selX][selY+1] == 0)) {
            dx = 0;
            dy = +1;
            moving = true;
            return true;
          }
        }
        return true;
      }

      // overrides Applet's stop method, not Thread's
      public void stop() {
        paintThread = null;
        repaint();
      }
  }